#include <windows.h>
#include <windowsx.h>
#include <stdio.h>
#include <stdlib.h>
#include <commctrl.h>
#include <string.h>
#include "Drawres.h"
#include "main.h"

void SetScroll(void)
{
  SCROLLINFO ScrollInfo;
  RECT Rect;
  GetClientRect(hwndMain, &Rect);
  memset(&ScrollInfo, 0, sizeof(ScrollInfo));
  ScrollInfo.cbSize = sizeof(ScrollInfo);
  ScrollInfo.fMask = SIF_RANGE | SIF_POS;
  ScrollInfo.nMax = GetDispWidth() - Rect.right;
  ScrollInfo.nPage = ScrollInfo.nMax/4;
  SetScrollInfo(hwndMain, SB_HORZ, &ScrollInfo, TRUE);
  ScrollInfo.nMax = GetDispHeight() - Rect.bottom;
  ScrollInfo.nPage = ScrollInfo.nMax/4;
  SetScrollInfo(hwndMain, SB_VERT, &ScrollInfo, TRUE);
  YOffset = 0;
  XOffset = 0;
}

void VScroll(int code, int pos)
{
  SCROLLINFO ScrollInfo;
  RECT Rect;
  int Line, Page;
  GetClientRect(hwndMain, &Rect);
  memset(&ScrollInfo, 0, sizeof(ScrollInfo));
  ScrollInfo.cbSize = sizeof(ScrollInfo);
  ScrollInfo.fMask = SIF_POS | SIF_RANGE;
  GetScrollInfo(hwndMain, SB_VERT, &ScrollInfo);
  Line = Rect.bottom/2;
  if(!Line)
    Line = 1;
  Page = Rect.bottom/10;
  if(!Page)
    Page = 1;
  switch(code)
  {
    case SB_LINEUP:
      ScrollInfo.nPos -= Line;
      break;
    case SB_LINEDOWN:
      ScrollInfo.nPos += Line;
      break;
    case SB_PAGEDOWN:
      ScrollInfo.nPos += Page;
      break;
    case SB_PAGEUP:
      ScrollInfo.nPos -= Page;
      break;
    case SB_THUMBPOSITION:
      ScrollInfo.nPos = pos;
      break;
    default:
      return;
  }
  if(ScrollInfo.nPos < 0)
    ScrollInfo.nPos = 0;
  else if(ScrollInfo.nPos > ScrollInfo.nMax)
    ScrollInfo.nPos = ScrollInfo.nMax;

  SetScrollInfo(hwndMain, SB_VERT, &ScrollInfo, TRUE);
  YOffset = ScrollInfo.nPos;
  InvalidateRect(hwndMain, 0, TRUE);
}

void HScroll(int code, int pos)
{
  SCROLLINFO ScrollInfo;
  RECT Rect;
  int Line, Page;
  GetClientRect(hwndMain, &Rect);
  memset(&ScrollInfo, 0, sizeof(ScrollInfo));
  ScrollInfo.cbSize = sizeof(ScrollInfo);
  ScrollInfo.fMask = SIF_POS | SIF_RANGE;
  GetScrollInfo(hwndMain, SB_HORZ, &ScrollInfo);
  Line = Rect.right/10;
  if(!Line)
    Line = 1;
  Page = Rect.right/2;
  if(!Page)
    Page = 1;
  switch(code)
  {
    case SB_LINELEFT:
      ScrollInfo.nPos -= Line;
      break;
    case SB_LINERIGHT:
      ScrollInfo.nPos += Line;
      break;
    case SB_PAGERIGHT:
      ScrollInfo.nPos += Page;
      break;
    case SB_PAGELEFT:
      ScrollInfo.nPos -= Page;
      break;
    case SB_THUMBPOSITION:
      ScrollInfo.nPos = pos;
      break;
    default:
      return;
  }
  if(ScrollInfo.nPos < 0)
    ScrollInfo.nPos = 0;
  else if(ScrollInfo.nPos > ScrollInfo.nMax)
    ScrollInfo.nPos = ScrollInfo.nMax;

  XOffset = ScrollInfo.nPos;
  SetScrollInfo(hwndMain, SB_HORZ, &ScrollInfo, TRUE);
  InvalidateRect(hwndMain, 0, TRUE);
}
